import gnu.io.CommPort;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;
import gnu.io.SerialPortEvent;
import gnu.io.SerialPortEventListener;

import java.awt.Color;
import java.awt.TextArea;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;



import javax.swing.*;
import javax.swing.text.BadLocationException;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

import netscape.javascript.JSObject;
import netscape.javascript.JSException;
import java.util.*; 
import java.util.regex.Matcher;
import java.util.regex.Pattern;
/**
 * This version of the TwoWaySerialComm example makes use of the
 * SerialPortEventListener to avoid polling.
 *
 */
public class TwoWaySerialComm2
{
	public static JTextPane t_area;   
	public InputStream in1;
	public OutputStream out1;
	public JSObject win;
	public CommPort commPort;
	public SerialPort serialPort;
	public String port_name;
	public int winflag=0;
	public static ATCommandTester_v19 atTester; 
	public static int send_to_parser;
	public static String last_cmd;
	public StyledDocument doc;
	public Style style;
    public TwoWaySerialComm2(JTextPane txt_area, JSObject win)
    {
    	super();
    	this.t_area = txt_area;	
    	this.win = win;
    	doc = t_area.getStyledDocument();
    	style = t_area.addStyle("Red", null);
        StyleConstants.setForeground(style, Color.black);
    	//Enumeration portList = CommPortIdentifier.getPortIdentifiers();
   } 	
   
    public void setOutputArea(JTextPane txt_area)
    {
    	this.t_area = txt_area;
    	doc = t_area.getStyledDocument();
    	style = t_area.addStyle("Red", null);
        StyleConstants.setForeground(style, Color.black);
     }
     
    //public void connect ( String portName,int speed ) throws Exception
    public String connect ( String portName,int speed) throws Exception
    {
    	String s,s1;
    	String ret = "connect_fail";
    	//System.out.println("Received message to connect to " + portName);
        //s = "Attempting to connect to " + portName + "at baud rate "+speed+"\r\n";
    	//s = "Attempting to connect to " + portName + "at baud rate "+"\r\n";
    		CommPortIdentifier portIdentifier = CommPortIdentifier.getPortIdentifier(portName);
        System.out.println("PortIdentifier is " + portIdentifier+"\r\n\r\n");
         if ( portIdentifier.isCurrentlyOwned() )
        {
            System.out.println("Error: Port is currently in use");
            StyleConstants.setForeground(style, Color.black);
            //t_area.setText("Error: " + portName +"Port is currently in use.");
            s1 = "\nError: " + portName +" port is currently in use.\n";  
            try {
				doc.insertString(doc.getLength(), s1, style);
			} catch (BadLocationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
            //if(winflag ==1)
				 //win.call("setMessage","connect_port_in_use"});
                 ret = "connect_port_in_use";
          //win.call("setMessage", new String[] {"Error: " + portName +"Port is currently in use \r\n"});
        }
        else
        {
        	 s= "Before opening portIdentifier open\r\n";
  //      	 win.call("setMessage", new String[] {s});
        	 try {
        		commPort = portIdentifier.open(this.getClass().getName(),2000);
     
             } catch (Exception e) {
                 System.out.println(e.getMessage());
                 //t_area.setText(t_area.getText()+portName+ " is currently in use. Please close the application that is using this port and connect again."+"\r\n\r\n");
                 StyleConstants.setForeground(style, Color.black);
                 //t_area.setText("Error: " + portName +"Port is currently in use.");
                 s1 = portName+"  is currently in use. Please close the application that is using this port and connect again."+"\r\n";  
                 try {
     				doc.insertString(doc.getLength(), s1, style);
     			} catch (BadLocationException e1) {
     				// TODO Auto-generated catch block
     				e.printStackTrace();
     			}
                 ret = "connect_port_in_use";
                 return ret;
             }
        	 
            
          
           // commPort = portIdentifier.open("ATCommandTester",5000);
        	
            System.out.println("commPort is " + commPort+"\r\n");
            //win.call("setMessage", new String[] {"Comport is " +commPort});
            
            if ( commPort instanceof SerialPort )
            {
                serialPort = (SerialPort) commPort;
                port_name = portIdentifier.getName();
                //win.call("setMessage", new String[] {"Configuring port" +portName});
                //serialPort.setSerialPortParams(speed,SerialPort.DATABITS_8,SerialPort.STOPBITS_1,SerialPort.PARITY_NONE);
                serialPort.setSerialPortParams(speed,SerialPort.DATABITS_8,SerialPort.STOPBITS_1,SerialPort.PARITY_NONE);
                //serialPort.setSerialPortParams(speed);
                InputStream in = serialPort.getInputStream();
                OutputStream out = serialPort.getOutputStream();
                in1 = in;
                out1 = out;
                
                             
                serialPort.addEventListener(new SerialReader(in1,win));
                serialPort.notifyOnDataAvailable(true);
                
                //t_area.setText(t_area.getText()+"\n"+"Connected to port " + portName+ " at baud rate "+speed+" bps.\r\n\r\n");
                
                StyleConstants.setForeground(style, Color.black);
                //t_area.setText("Error: " + portName +"Port is currently in use.");
                s1 = "Connected to port " + portName+ " at baud rate "+speed+" bps.\r\n\r\n";  
                //try {
    				//doc.insertString(doc.getLength(), s1, style);
    			//} catch (BadLocationException e) {
    				// TODO Auto-generated catch block
    				//e.printStackTrace();
    			//}
                //if(winflag ==1)
					 //win.call("setMessage", new String[] {"connect_success"});
					 ret = "connect_sucess";

            }
            else
            {
                System.out.println("Error: Only serial ports are handled by this example.");
                
                ret = "connect_error";
  //              t_area.setText(t_area.getText()+"Error connecting to " + portName+ ".\r\n\r\n");
                
                StyleConstants.setForeground(style, Color.black);
                s1 = "Error connecting to " + portName+ ".\r\n";  
                try {
    				doc.insertString(doc.getLength(), s1, style);
    			} catch (BadLocationException e) {
    				// TODO Auto-generated catch block
    				e.printStackTrace();
    			}
                //win.call("setMessage", new String[] {"Error: Only serial ports are handled by this program\r\n"});
                
            }
        }
        //s= "End of function\r\n";
        //win.call("setMessage", new String[] {s});
         return ret;
    }
    
    public String listPorts()
    {
    	ArrayList<String> port_name = new ArrayList(); 
    	 String tmp="";
    	 String tmp2;
    	int i=0;
        java.util.Enumeration<CommPortIdentifier> portEnum = CommPortIdentifier.getPortIdentifiers();
    	//System.loadLibrary("RXTXComm.dll");
    	Enumeration portList = CommPortIdentifier.getPortIdentifiers();
               while ( portEnum.hasMoreElements() ) 
        {
            CommPortIdentifier portIdentifier = portEnum.nextElement();
            if(getPortTypeName(portIdentifier.getPortType()) == "Serial")
            {	
              port_name.add(portIdentifier.getName());
              tmp2 = portIdentifier.getName()+ "#";
              //win.call("setMessage", new String[] {"Found port"+tmp2+ "\r\n"});
              tmp += tmp2;
            }  
            System.out.println(portIdentifier.getName()  +  " - " +  getPortTypeName(portIdentifier.getPortType()) );
        }    
        i = port_name.size();
        //String[] strArray = new String[i];
        //String[] strArray  = { "COM8" , "COM9"};
        //String[] a = port_name.toArray(strArray);
        //String tmp =  Arrays.toString(strArray);      
        //t_area.append("New Request\n");
    
         //win.call("setMessage", new String[] {"Found ports"+tmp+ "\r\n"});
       // t_area.append("Found ports"+ tmp+"\n");
        //win.call("setMessage", new String[] {"Found ports"+ tmp+"\n"});
        return (tmp);
        //return("way");
        
    }
    
    public String disconnect()
    {
    	String ret = "disconnect_fail";
    	if(serialPort != null)
    	{
    		try{
    			in1.close();
    			out1.close();
    		}catch (IOException ex)
    		{
    			
    		}
    	//	t_area.setText(t_area.getText()+"\n"+"Disconnecting port "+ port_name+".\r\n\r\n");	
            StyleConstants.setForeground(style, Color.black);
            String s1 = "Disconnecting port "+ port_name+".\r\n\r\n";  
            try {
				doc.insertString(doc.getLength(), s1, style);
			} catch (BadLocationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
    		serialPort.close();
         serialPort = null;
         //if(winflag ==1)
			 //win.call("setMessage", new String[] {"disconnect_success"});
           ret = "disconnect_success";
    	} 
    	else
    	{
    		
    		//t_area.setText(t_area.getText()+"\n"+"No port is connected" +".\r\n\r\n");	
    		StyleConstants.setForeground(style, Color.black);
            String s1 = "No port is connected" +".\r\n\r\n";  
            try {
				doc.insertString(doc.getLength(), s1, style);
			} catch (BadLocationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 
    		//if(winflag ==1)
				 //win.call("setMessage", new String[] {"disconnect_no_port"});
    		ret = "disconnect_port_not_selected";
    	}
    	return ret;
    }
    
    static String getPortTypeName ( int portType )
    {
        switch ( portType )
        {
            case CommPortIdentifier.PORT_I2C:
                return "I2C";
            case CommPortIdentifier.PORT_PARALLEL:
                return "Parallel";
            case CommPortIdentifier.PORT_RAW:
                return "Raw";
            case CommPortIdentifier.PORT_RS485:
                return "RS485";
            case CommPortIdentifier.PORT_SERIAL:
                return "Serial";
            default:
                return "unknown type";
        }
    }
    
    public String ser_write(String str,int type)
    {
    	String ret = "submit_fail";
    	if(serialPort != null)
    	{
    		try
            {
                //str ="AT\n";
    			System.out.println(str);
        		out1.write(str.getBytes());
        		//out1.write("AT");
        		//update last_cmd only if it 1
        		if(type==1)
        		{	
    			String t5[]= str.split("\r\n");
    			last_cmd = t5[0];
        		}
        		ret = "submit_data_written";
            }
            catch ( Exception e )
            {
                   e.printStackTrace();
            }
        
    	} 
    	else
    	{
    		//t_area.setText(t_area.getText()+"\n"+"No port is connected." +"\r\n\r\n");	
    		StyleConstants.setForeground(style, Color.black);
            String s1 = "No port is connected" +".\r\n\r\n";  
            try {
				doc.insertString(doc.getLength(), s1, style);
			} catch (BadLocationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 
    		ret = "submit_port_not_connected";
    	}
    	
    	return ret;
    	
    }
    
    public String check_port_connected()
    {
    	String ret = "NULL";
    	if(serialPort != null)
    	{
    		ret = serialPort.getName();
        
    	} 
    	    	
    	return ret;
    	
    }
    
    
   
    /**
     * Handles the input coming from the serial port. A new line character
     * is treated as the end of a block in this example.
     */
    public static class SerialReader implements SerialPortEventListener
    {
        private InputStream in;
        private byte[] portBuffer = new byte[1024];
        private String fileBuffer;
       public JSObject win;
       public int winflag=1;
       static int j;
       static ArrayList resp_array= new ArrayList();
        public SerialReader ( InputStream in,JSObject win )
        {
            this.in = in;
            this.win = win;
        }
       
        public void serialEvent(SerialPortEvent arg0) {
            int data;
            String tstr,t1,t2;
            String delimiter = "\r\n";
            String temp[],temp1[];
            
            
            try
            {
                int len = 0;
                while ( ( data = in.read()) > -1 )
                {
                        portBuffer[len++] = (byte) data;
                        if ( data == '\n' ) {
                        break;
                    }
                   
                }
                                fileBuffer = new String(portBuffer,0,len);
                                java.util.Date today = new java.util.Date();
                                String date = new java.sql.Timestamp(today.getTime()).toString();
                                //fileBuffer = fileBuffer.replaceAll("@", "\n" + date + "|");
                                System.out.print(fileBuffer.toString());
                                tstr = fileBuffer.toString();
                                StyledDocument doc = t_area.getStyledDocument();
                            	Style style = t_area.addStyle("Red", null);
                                StyleConstants.setForeground(style, Color.blue);
                                StyleConstants.setItalic(style, true);
                                StyleConstants.setFontSize( style, 10 );
                                if(tstr.contains("RING"))
                                {
                                	atTester.at_parser("RING",null);
                                	return;
                                }
                                if(tstr.contains("CONNECT OK"))
                                {
                                	 try {
  										doc.insertString(doc.getLength(), tstr, style);
  									} catch (BadLocationException e) {
  										// TODO Auto-generated catch block
  										e.printStackTrace();
  									}
                                	atTester.at_parser("CONNECT OK",null);
                                	return;
                                }
                                if(tstr.contains("CLOSE"))
                                {
                                	 try {
  										doc.insertString(doc.getLength(), tstr, style);
  									} catch (BadLocationException e) {
  										// TODO Auto-generated catch block
  										e.printStackTrace();
  									}	
                                	atTester.at_parser("CLOSE",null);
                                	return;
                                }
                                if(tstr.contains("NO CARRIER"))
                                {
                                	 try {
  										doc.insertString(doc.getLength(), tstr, style);
  									} catch (BadLocationException e) {
  										// TODO Auto-generated catch block
  										e.printStackTrace();
  									}
                                	atTester.at_parser("NO CARRIER",null);
                                	return;
                                }
                                if(tstr.contains("+HTTPACTION:0"))
                                { 
                                	temp = tstr.split(delimiter);
                                	resp_array.clear();
                                	resp_array.add(temp[0]);
                                	atTester.at_parser("AT+HTTPACTION=",resp_array);
                                	return;
                                }
                                if(tstr.contains("+FTPPUT:1,"))
                                { 
                                	temp = tstr.split(delimiter);
                                	temp1 = temp[0].split(":");
                                	temp1 = temp1[1].split(",");
                                	last_cmd = "+FTPPUT:";
                                	resp_array.clear();
                                	resp_array.add(temp1[0]);
                                	resp_array.add(temp1[1]);
                                	if(temp1[1].equals("1"))
                                	 resp_array.add(temp1[2]);
                                	 try {
 										doc.insertString(doc.getLength(), tstr, style);
 									} catch (BadLocationException e) {
 										// TODO Auto-generated catch block
 										e.printStackTrace();
 									}
                                	atTester.at_parser(last_cmd,resp_array);
                                	return;
                                  }
                                if(tstr.contains("+FTPPUT:2,"))
                                { 
                                	temp = tstr.split(delimiter);
                                	temp1 = temp[0].split(":");
                                	temp1 = temp1[1].split(",");
                                	last_cmd = "+FTPPUT:";
                                	resp_array.clear();
                                	resp_array.add(temp1[0]);
                                	resp_array.add(temp1[1]);
                                	try {
 										doc.insertString(doc.getLength(), tstr, style);
 									} catch (BadLocationException e) {
 										// TODO Auto-generated catch block
 										e.printStackTrace();
 									}
                                	atTester.at_parser(last_cmd,resp_array);
                                	return;
                                  }
                                if(tstr.contains("+FTPGET:1,"))
                                { 
                                	temp = tstr.split(delimiter);
                                	temp1 = temp[0].split(":");
                                	last_cmd = "+FTPGET:";
                                	resp_array.clear();
                                	resp_array.add(temp1[1]);
                                	 try {
 										doc.insertString(doc.getLength(), tstr, style);
 									} catch (BadLocationException e) {
 										// TODO Auto-generated catch block
 										e.printStackTrace();
 									}
                                	atTester.at_parser(last_cmd,resp_array);
                                	return;
                                  }
                                if(tstr.contains("+FTPGET:2,"))
                                { 
                                	temp = tstr.split(delimiter);
                                	temp1 = temp[0].split(":");
                                	temp = tstr.split(":");
                                	last_cmd = "+FTPGET:";
                                	resp_array.clear();
                                	resp_array.add(temp1[1]);
                                	 try {
 										doc.insertString(doc.getLength(), tstr, style);
 									} catch (BadLocationException e) {
 										// TODO Auto-generated catch block
 										e.printStackTrace();
 									}
                                	return; 
                                }
                                //text.setFont(font);
                                //Sometimes Telit module is sending unsolicited AT on teh serial port. Just ignore it.
                            	if(tstr.equals("AT"))
                            	{
                            		resp_array.clear();
                            		return;
                            	}
                                if(send_to_parser==1)
                                {   
                                	
                                	                                  
                                     //t_area.setForeground(Color.blue);
                                    try {
										doc.insertString(doc.getLength(), tstr, style);
									} catch (BadLocationException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
                                     //t_area.setText(t_area.getText()+tstr);
                                     //t_area.setForeground(Color.black);
                                	 //t_area.setForeground(Color.black);
                                	if(tstr.equals(last_cmd+"\r\r\n")|| tstr.equals(last_cmd+"\r\n"))
                                	{
                                		resp_array.clear();
                                		//System.out.println("Echo Mode On");
                                   }
                                	else
                                	{
                                	temp = tstr.split(delimiter);
                                	if(temp[0].contains("ERROR"))
                                	{
                                		resp_array.add(temp[0]);
                                		atTester.at_parser(last_cmd,resp_array);
                                		resp_array.clear();
                                	}
                                	else if(temp[0].equals("OK"))
                                	{
                                		resp_array.add(temp[0]);
                                		atTester.at_parser(last_cmd,resp_array);
                                		resp_array.clear();
                                	}
                                	else if(temp[0]!="")
                                	{
                                		resp_array.add(temp[0]);
                                    }
                                	}
                                }
                                else
                                {	
                                	 try {
 										doc.insertString(doc.getLength(), tstr, style);
 									} catch (BadLocationException e) {
 										// TODO Auto-generated catch block
 										e.printStackTrace();
 									}
                                	//t_area.setText(t_area.getText()+tstr);
                                }
                                	//if(winflag ==1)
           						 //win.call("setMessage", new String[] {"submit_response"});
                                //out.write(fileBuffer.toString());
                    //out.flush();
                    //System.out.print(fileBuffer.toString());
            }
            catch ( IOException e )
            {
                e.printStackTrace();
                System.exit(-1);
            }            
        }

    }

    /** */
    public static class SerialWriter implements Runnable
    {
        OutputStream out;
       
        public SerialWriter ( OutputStream out )
        {
            this.out = out;
        }
       
        public void run ()
        {
            try
            {                
                int c = 0;
                while ( ( c = System.in.read()) > -1 )
                {
                    this.out.write(c);
                }                
            }
            catch ( IOException e )
            {
                e.printStackTrace();
                System.exit(-1);
            }            
        }
    }
   
      
    /*public static void main ( String[] args )
    {
    	//System.loadLibrary("rxtxSerial");
    	
        try
        {
            (new TwoWaySerialComm2()).connect("COM16");
        }
        catch ( Exception e )
        {
               e.printStackTrace();
        }
    }*/

}
